!     ******************************************************************
!     qtXLSDeclarations.f90
!     Copyright(c) QT software GmbH 2003
!
!     Created: 02.09.2003 10:49:31
!     Author : J. Kuthe
!     Last change: JK 02.09.2003 11:15:52
!     ******************************************************************

MODULE qtXLSDeclarations
! KINDs
	INTEGER, PARAMETER :: qt_K_INT1 = SELECTED_INT_KIND(2)			! 1 Byte Integer (-10^2 < n < 10^2)
	INTEGER, PARAMETER :: qt_K_INT2 = SELECTED_INT_KIND(3)			! 2 Byte Integer (-10^3 < n < 10^3)
	INTEGER, PARAMETER :: qt_K_INT4 = SELECTED_INT_KIND(9)			! 4 Byte Integer (-10^10 < n < 10^10)
	INTEGER, PARAMETER :: qt_K_R4 = SELECTED_REAL_KIND(5,36)		! 4 Byte REAL (dec. range: 10^36, prec.: 5 digits)
	INTEGER, PARAMETER :: qt_K_R8 = SELECTED_REAL_KIND(15, 307)	! 8 Byte REAL (dec. range: 10^307, prec.: 15 digits)

	INTEGER, PARAMETER :: qt_K_LP = qt_K_INT4

	INTEGER, PARAMETER :: qt_K_SMALLINT = qt_K_INT2
	INTEGER, PARAMETER :: qt_K_UINTEGER = qt_K_INT4
	INTEGER, PARAMETER :: qt_K_INTEGER = qt_K_INT4
	INTEGER, PARAMETER :: qt_K_HANDLE = qt_K_INT4
	INTEGER, PARAMETER :: qt_K_RETURN = qt_K_SMALLINT

! Constants
	INTEGER, PARAMETER :: qt_I_MaxPathLEN = 1024
	INTEGER, PARAMETER :: qt_I_MaxTableNameLEN = 20480    ! vorher 256
	INTEGER, PARAMETER :: qt_I_MaxColumneNameLEN = 64		! eigentlich 64 + 1 (aber wegen Problemen mit Alignment bei LF95/win32 v5.7, der ein 4-Byte Boundary Alignment fordert, "nur" 64)
	INTEGER, PARAMETER :: qt_I_MaxStatementLEN = 20480		! qt_I_MAXTABLENAMELEN + 255 * (64 + 8 + 3) + 18 ca. 20000: max. 255 Spalten, max. 64 Zeichen pro Spalte, max. 8 Zeichen pro Typ, 3 Trennzeichen 
	INTEGER, PARAMETER :: qt_I_SQLDataTypeLEN = 42			! max. length of SQL Data Type names like VARCHAR, NUMBER etc.

   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_CHAR = 1
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_NUMERIC = 2
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_DECIMAL = 3
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_INTEGER = 4
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_SMALLINT = 5
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_FLOAT = 6
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_REAL = 7
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_DOUBLE = 8
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_DATETIME = 9
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_VARCHAR = 12
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_TYPE_DATE = 91
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_TYPE_TIME = 92
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_TYPE_TIMESTAMP = 93
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_DATE = 9
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_INTERVAL = 10
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_TIME = 10
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_TIMESTAMP = 11
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_LONGVARCHAR = -1
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_BINARY = -2
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_VARBINARY = -3
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_LONGVARBINARY = -4
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_BIGINT = -5
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_TINYINT = -6
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_BIT = -7
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_GUID = -11

   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_CHAR = qt_SQL_CHAR
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_LONG = qt_SQL_INTEGER
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_SHORT = qt_SQL_SMALLINT
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_FLOAT = qt_SQL_REAL
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_DOUBLE = qt_SQL_DOUBLE
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_NUMERIC = qt_SQL_NUMERIC
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_DEFAULT = 99
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_SIGNED_OFFSET = -20
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_UNSIGNED_OFFSET = -22
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_DATE = qt_SQL_DATE
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_TIME = qt_SQL_TIME
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_TIMESTAMP = qt_SQL_TIMESTAMP
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_TYPE_DATE = qt_SQL_TYPE_DATE
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_TYPE_TIME = qt_SQL_TYPE_TIME
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_TYPE_TIMESTAMP = qt_SQL_TYPE_TIMESTAMP
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_BINARY = qt_SQL_BINARY
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_BIT = qt_SQL_BIT
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_SBIGINT = qt_SQL_BIGINT+qt_SQL_SIGNED_OFFSET
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_UBIGINT = qt_SQL_BIGINT+qt_SQL_UNSIGNED_OFFSET
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_TINYINT = qt_SQL_TINYINT
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_SLONG = qt_SQL_C_LONG+qt_SQL_SIGNED_OFFSET
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_SSHORT = qt_SQL_C_SHORT+qt_SQL_SIGNED_OFFSET
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_STINYINT = qt_SQL_TINYINT+qt_SQL_SIGNED_OFFSET
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_ULONG = qt_SQL_C_LONG+qt_SQL_UNSIGNED_OFFSET
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_USHORT = qt_SQL_C_SHORT+qt_SQL_UNSIGNED_OFFSET
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_UTINYINT = qt_SQL_TINYINT+qt_SQL_UNSIGNED_OFFSET
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_BOOKMARK = qt_SQL_C_ULONG
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_GUID = qt_SQL_GUID
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_TYPE_NULL = 0
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_TYPE_MIN = qt_SQL_BIT
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_TYPE_MAX = qt_SQL_VARCHAR
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_C_VARBOOKMARK = qt_SQL_C_BINARY
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_NO_ROW_NUMBER = -1
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_NO_COLUMN_NUMBER = -1
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_ROW_NUMBER_UNKNOWN = -2
   INTEGER (qt_K_INT2), PARAMETER :: qt_SQL_COLUMN_NUMBER_UNKNOWN = -2

! Error codes
	INTEGER, PARAMETER :: qtERRORBase = 70000
	INTEGER, PARAMETER :: qtERRORNotZeroTerminated		= qtERRORBase + 1
	INTEGER, PARAMETER :: qtERRORAllocHandleFailed		= qtERRORBase + 2
	INTEGER, PARAMETER :: qtERRORSQLFunctionFailed		= qtERRORBase + 3
	INTEGER, PARAMETER :: qtERRORConnectFailed			= qtERRORBase + 4
	INTEGER, PARAMETER :: qtERRORInsufficientDimension	= qtERRORBase + 5
	INTEGER, PARAMETER :: qtERRORNameNotSpecified		= qtERRORBase + 6
	INTEGER, PARAMETER :: qtERRORInvalid					= qtERRORBase + 7
	INTEGER, PARAMETER :: qtERRORExecDirectFailed		= qtERRORBase + 8
	INTEGER, PARAMETER :: qtERRORInsufficientSize		= qtERRORBase + 9
	INTEGER, PARAMETER :: qtERRORNotSupported				= qtERRORBase + 10
	!INTEGER, PARAMETER ::  = qtERRORBase + 1

	INTEGER, PARAMETER :: qtERRORUnknown					= qtERRORBase + 200	! the last error code

! TYPEs
	TYPE qT_ColumnInfo
		SEQUENCE
		CHARACTER (qt_I_MaxColumneNameLEN)	szName		! column name (zero terminated)
		INTEGER (qt_K_SMALLINT)					SQLDataType	! ODBC SQL data type (e.g. qt_SQL_TYPE_DATE or qt_SQL_INTERVAL_YEAR_TO_MONTH
		CHARACTER (qt_I_SQLDataTypeLEN)		TypeName		! column type name (datasource dependent; for example, CHAR, VARCHAR, MONEY, LONG VARBINAR, or CHAR ( ) FOR BIT DATA.
		INTEGER (qt_K_INT4)						MaxLen		! IF SQLDataType == qt_SQL_CHAR or qt_SQL_VARCHAR, the maximum length in characters of the column is returned. For datetime data types, this is the total number of characters required to display the value when converted to characters. For numeric data types, this is either the total number of digits or the total number of bits allowed in the column, according to the NUM_PREC_RADIX column. For interval data types, this is the number of characters in the character representation of the interval literal (as defined by the interval leading precision, see Interval Data Type Length in Appendix D, Data Types). For more information, see Column Size, Decimal Digits, Transfer Octet Length, and Display Size in Appendix D, Data Types.
		! mehr evt. spter (vgl. SDK: SQLColumns)
	END TYPE

	TYPE qT_SQLColumn
		SEQUENCE
		CHARACTER (qt_I_MaxColumneNameLEN)	Name			! column name (either zero terminated or blank padded)
		INTEGER (qt_K_LP)							ArrayAddr	! LOC(array for results)
		INTEGER (qt_K_INT4)						ArrayDim		! ArrayDimension 
		INTEGER (qt_K_INT4)						ArrayType	! type of array (qt_SQL_C_...: qt_SQL_C_SSHORT, qt_SQL_C_SLONG, qt_SQL_C_DOUBLE, qt_SQL_C_FLOAT, qt_SQL_C_CHAR, qt_SQL_C_DATE, qt_SQL_C_BIT ...). This usually also determines the length of a single array element (in bytes), but not for strings
		INTEGER (qt_K_INT4)						LENArrElem	! length of single array element in characters in case of string arrays
		INTEGER (qt_K_LP)							IndArrAddr	! now: not used, should be 0; later: LOC() of result indicator array (result = qt_SQL_NULL_DATA (=-1) or valid value (=0)) or length of result (>0))
	END TYPE

	TYPE qT_DATE_STRUCT
		SEQUENCE
		INTEGER (qt_K_SMALLINT )	year
		INTEGER (qt_K_SMALLINT )	month
		INTEGER (qt_K_SMALLINT )	day
	END TYPE

	TYPE  qT_TIME_STRUCT
		SEQUENCE
		INTEGER (qt_K_SMALLINT)	hour
		INTEGER (qt_K_SMALLINT)	minute
		INTEGER (qt_K_SMALLINT)	second
	END TYPE

	TYPE  qT_TIMESTAMP_STRUCT
		SEQUENCE
		INTEGER (qt_K_SMALLINT)	year
		INTEGER (qt_K_SMALLINT)	month
		INTEGER (qt_K_SMALLINT)	day
		INTEGER (qt_K_SMALLINT)	hour
		INTEGER (qt_K_SMALLINT)	minute
		INTEGER (qt_K_SMALLINT)	second
		INTEGER (qt_K_UINTEGER)	fraction
	END TYPE

   INTEGER, PARAMETER :: qt_SQL_MAX_NUMERIC_LEN = 16

	TYPE  qT_NUMERIC_STRUCT
		SEQUENCE
		INTEGER (qt_K_INT1) precision								! The precision and scale fields of the qt_SQL_C_NUMERIC data type are never used for input from an application, only for output from the driver to the application. When the driver writes a numeric value into the qt_SQL_NUMERIC_STRUCT, it will use its own driver-specific default as the value for the precision field, 		
		INTEGER (qt_K_INT1) scale									! and it will use the value in the qt_SQL_DESC_SCALE field of the application descriptor (which defaults to 0) for the scale field. An application can provide its own values for precision and scale by setting the qt_SQL_DESC_PRECISION and qt_SQL_DESC_SCALE fields of the application descriptor.
		INTEGER (qt_K_INT1) sign									! 1 if positive, 0 if negative
		INTEGER (qt_K_INT1) val(qt_SQL_MAX_NUMERIC_LEN)	! A number is stored in the val field of the qt_SQL_NUMERIC_STRUCT structure as a scaled integer, in little endian mode (the leftmost byte being the least-significant byte). For example, the number 10.001 base 10, with a scale of 4, is scaled to an integer of 100010. Because this is 186AA in hexadecimal format, the value in qt_SQL_NUMERIC_STRUCT would be "AA 86 01 00 00 ... 00", with the number of bytes defined by the qt_SQL_MAX_NUMERIC_LEN #define (=16).
	END TYPE

!-----------------------------------------------------------------------------
! (C) Copyright QT software GmbH, Munich, Germany, 2003. All rights reserved.
END MODULE